# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define base_name jcs
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Summary:        Java Caching System
Name:           apache-commons-jcs
Version:        1.3.3.5
Release:        1%{?dist}
Epoch:          0
License:        Apache Software License
URL:            http://commons.apache.org/jcs/
Group:          Development/Libraries
Source0:        apache-commons-jcs-1.3.3.5.tgz
# svn export http://svn.apache.org/repos/asf/commons/proper/jcs/tags/JCS_1_3_3_5/ apache-commons-jcs-1.3.3.5
# tar czf ../SOURCES/apache-commons-jcs-1.3.3.5.tgz apache-commons-jcs-1.3.3.5/
Source1:        apache-commons-jcs-settings.xml
Source2:        apache-commons-jcs-jpp-depmap.xml
Patch0:         apache-commons-jcs-project.patch
Patch1:         apache-commons-jcs-pom.patch
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-one-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-remote-resources-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  mojo-cobertura-maven-plugin
BuildRequires:  junit
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.7.1

BuildRequires:  berkeleydb
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-configuration
BuildRequires:  apache-commons-dbcp
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-pool
BuildRequires:  concurrent
BuildRequires:  hsqldb
BuildRequires:  log4j
BuildRequires:  mysql-connector-java
BuildRequires:  servlet_2_3_api
BuildRequires:  tomcat5-server-lib
BuildRequires:  velocity15
BuildRequires:  xmlrpc2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis

Requires:  java >= 0:1.6.0
Requires:  /usr/sbin/update-alternatives
Requires:  apache-commons-codec
Requires:  apache-commons-collections
Requires:  apache-commons-configuration
Requires:  apache-commons-dbcp
Requires:  apache-commons-httpclient
Requires:  apache-commons-lang
Requires:  apache-commons-logging
Requires:  apache-commons-pool
Requires:  concurrent
Requires:  hsqldb
Requires:  log4j
Requires:  servlet_2_3_api
Requires:  tomcat5-server-lib
Requires:  velocity15
Requires:  xmlrpc2
Provides:  hibernate_in_process_cache
Provides:  jakarta-turbine-jcs = %{epoch}:%{version}-%{release}
Obsoletes: jakarta-turbine-jcs < %{epoch}:%{version}-%{release}
Provides:  jakarta-jcs = %{epoch}:%{version}-%{release}
Obsoletes: jakarta-jcs < %{epoch}:%{version}-%{release}
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%description
JCS is a distributed caching system written in java 
for server-side java applications. It is intended to 
speed up dynamic web applications by providing a means 
to manage cached data of various dynamic natures. 
Like any caching system, the JCS is most useful for 
high read, low put applications. Dynamic content and 
reporting systems can benefit most. 
However, any site that repeatedly constructs pages, 
dropdowns, or common search results form a database 
that is updated at intervals (rather than across 
categories continuously) can improve performance and 
scalability by implementing caching. Latency times drop 
sharply and bottlenecks move away from the database in 
an effectively cached system. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:  jakarta-turbine-jcs-javadoc
Obsoletes: jakarta-turbine-jcs-javadoc
Provides:  jakarta-jcs-javadoc
Obsoletes: jakarta-jcs-javadoc

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation
Provides:  jakarta-turbine-jcs-manual
Obsoletes: jakarta-turbine-jcs-manual
Provides:  jakarta-jcs-manual
Obsoletes: jakarta-jcs-manual

%description manual
Docs for %{name}.

%prep
%setup -q 
# remove all binary libs
## find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav0
cp %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2_SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        one:convert
patch < %{PATCH1}
mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc site

#       -Dmaven.test.failure.ignore=true \

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 target/%{base_name}-%{version}-RC.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/ && ln -s %{name}-%{version}.jar %{base_name}-%{version}.jar)
(cd $RPM_BUILD_ROOT%{_javadir}/ && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
## ear, war
#mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
#install -m 0644 target/%{base_name}-%{version}-RC.ear \
#                $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
#install -m 0644 target/%{base_name}.war \
#                $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# hibernate_in_process_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_in_process_cache.jar


%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_in_process_cache.jar \
  hibernate_in_process_cache %{_javadir}/%{name}.jar 10

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_in_process_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*jcs*.jar
%ghost %{_javadir}/hibernate_in_process_cache.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Aug 10 2012 Ralph Apel <r.apel at r-apel.de> - 0:1.3.3.5-1
- 1.3.3.5

* Fri Apr 24 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.3.2.8-1.jpp5
- 1.3.2.8

* Mon Aug 06 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-7jpp
- Change dependency from xmlrpc to xmlrpc2

* Fri May 04 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-6jpp
- Fix depmap for tomcat5/tomcat-util.jar
- Add more maven-plugin-* BRs

* Wed Mar 07 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-5jpp
- Add gcj_support option
- Optionally build without maven

* Wed May 10 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-4jpp
- Drop struts11, servletapi3 dependencies and use struts,servletapi4 

* Mon Mar 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7.0-3jpp
- Use tomcat-util.jar from Tomcat 5

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7.0-2jpp
- Add missing dependencies on maven-plugins

* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-1jpp
- Update to 1.2.7.0
- First JPP-1.7 release
- enabling UDP port 6789 in firewall rules is required for successful
  org.apache.jcs.auxiliary.lateral.socket.tcp.discovery.UDPDiscoveryUnitTest
- maven-simian-report has been pacthed out

* Mon Oct 31 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.3jpp
- Add Provides: jakarta-turbine-jcs-javadoc
- Add Provides: jakarta-turbine-jcs-manual

* Mon Oct 31 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.2jpp
- Change name to jakarta-jcs and provide compatibility symlinks
- Fix Url
- Obsolete jakarta-turbine-jcs

* Fri Oct 28 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.1jpp
- Upgrade to 1.2.6.5
- One test in TestUDPDiscovery failing

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-0.20031216dev.4jpp
- Rebuild with ant-1.6.2
* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.3jpp
- Relax some versioned dependencies
- provide hibernate_in_process_cache and update-alternatives, prio 10

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.2jpp
- set dependency to jisp2, instead of jisp

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.1jpp
- First JPackage release

